%define	gem_name	linecache19

%define	repoid		75414

%define	ruby_majorver	1.9
%define ruby_version	1.9.3
%define ruby_patchlevel	p392

Summary:	Read file with caching
Name:		ruby-%{gem_name}
Version:	0.5.13
Release:	%mkrel 5

Group:		Development/Ruby
# README file
License:	GPLv2
URL:		http://rubyforge.org/projects/ruby-debug19
# 0.5.12 on rubygems site doesn't work with ruby 1.9
#Source0:	http://rubygems.org/gems/%%{gem_name}-%%{version}.gem
Source0:	http://rubyforge.org/frs/download.php/%{repoid}/%{gem_name}-%{version}.gem
# linecache uses headers in ruby tarball which are not installed
# by default...
Source1:	ftp://ftp.ruby-lang.org/pub/ruby/%{ruby_majorver}/ruby-%{ruby_version}-%{ruby_patchlevel}.tar.bz2
Patch0:		rubygem-linecache19-0.5.12-dont_use_ruby_core_source.patch
Patch1:		rubygem-linecache19-0.5.12-system-path.patch

BuildRequires:	ruby-devel = %{ruby_version}.%{ruby_patchlevel}
BuildRequires:	ruby-RubyGems
BuildRequires:	ruby-devel
BuildRequires:	rubygem(minitest)
Provides:       rubygem(linecache) = %{version}
Obsoletes:	ruby-linecache < 0.49

%description
The LineCache module allows one to get any line from any file, caching
the lines and file information on first access to the file. Although
the file may be any file, the common use is when the file is a Ruby
script since parsing of the file is done to figure out where the
statement boundaries are.

The routines here may be is useful when a small random sets of lines
are read from a single file, in particular in a debugger to show
source lines.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}
Obsoletes:	ruby-linecache-doc < 0.49
BuildArch:	noarch

%description doc
Documentation for %{name}

%prep
%setup -q -c -T -a 1

# Gem repack
TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

gem unpack %{SOURCE0}
cd %{gem_name}-%{version}

# permission
find . -type f -print0 | xargs --null chmod 0644

# shebang
find ./lib -name \*.rb -print0 | \
	xargs --null sed -i -e '\@^#!%{_bindir}@d'

# Kill ruby_core_source dependency - this is
# just to download ruby tarball
gem specification  -l --ruby %{SOURCE0} | \
	sed -e '\@ruby_core_source@d' > %{gem_name}.gemspec

# Patch
%patch0 -p1
%patch1 -p1

gem build %{gem_name}.gemspec
mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

# Kill unneeeded ruby files
mkdir ruby_headers
# So the actual files needed are header files under
# ruby-%%ruby_fullver directory only
cp -p ruby-%{ruby_version}-%{ruby_patchlevel}/*.h ruby_headers/
rm -rf ruby-%{ruby_version}-%{ruby_patchlevel}/

%build
mkdir -p .%{gem_dir}

export CONFIGURE_ARGS="--with-cflags=\"%{optflags} -I$(pwd)/ruby_headers\""
gem install \
	--local \
	--install-dir .%{gem_dir} \
	-V \
	--force \
	%{gem_name}-%{version}.gem

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
	%{buildroot}%{gem_dir}/

mkdir -p %{buildroot}%{gem_extdir}/lib
mv \
	%{buildroot}%{gem_instdir}/lib/trace_nums19.so \
	%{buildroot}%{gem_extdir}/lib/

rm -rf %{buildroot}%{gem_instdir}/ext

%check
pushd .%{gem_instdir}
testrb -Ilib test/test-*.rb
popd

%files
%dir	%{gem_instdir}
%doc	%{gem_instdir}/[A-Z]*
%exclude	%{gem_instdir}/Rakefile
%{gem_libdir}
%dir	%{gem_extdir}
%dir	%{gem_extdir}/lib
%{gem_extdir}/lib/trace_nums19.so
%exclude	%{gem_cache}
%{gem_spec}

%files doc
%{gem_docdir}/
%exclude	%{gem_instdir}/test/


%changelog

* Thu Feb 28 2013 fwang <fwang> 0.5.13-5.mga3
+ Revision: 400578
- upload tarball
- upload tarball
- rebuild for new ruby

* Fri Feb 08 2013 fwang <fwang> 0.5.13-4.mga3
+ Revision: 396862
- rebuild for new rdoc

* Mon Jan 21 2013 fwang <fwang> 0.5.13-3.mga3
+ Revision: 390413
- update obsoletes

* Mon Jan 21 2013 fwang <fwang> 0.5.13-2.mga3
+ Revision: 390391
- fix dir
- obsoletes old package
- cleanup spec

* Mon Jan 21 2013 dmorgan <dmorgan> 0.5.13-1.mga3
+ Revision: 390352
- imported package ruby-linecache19

